diff --git a/test/periphery-lld/DW1000_v1/aos_test_DW1000.c b/test/periphery-lld/DW1000_v1/aos_test_DW1000.c
new file mode 100644
index 0000000..84bbd0e
--- /dev/null
+++ b/test/periphery-lld/DW1000_v1/aos_test_DW1000.c
@@ -0,0 +1,405 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_DW1000.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <aos_debug.h>
+#include <chprintf.h>
+#include <aos_thread.h>
+#include <math.h>
+#include <module.h>
+#include <alld_DW1000.h>
+#include <deca_instance.h>
+
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+//#define TEST_SNIPPETS_DW1000   // switch between test and demo apps
+
+#define SWS1_SHF_MODE 0x02  //short frame mode (6.81M)
+#define SWS1_CH5_MODE 0x04  //channel 5 mode
+#define SWS1_ANC_MODE 0x08  //anchor mode
+#define SWS1_A1A_MODE 0x10  //anchor/tag address A1
+#define SWS1_A2A_MODE 0x20  //anchor/tag address A2
+#define SWS1_A3A_MODE 0x40  //anchor/tag address A3
+
+#define S1_SWITCH_ON  (1)
+#define S1_SWITCH_OFF (0)
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+uint8_t s1switch = 0;
+int instance_anchaddr = 0;
+int dr_mode = 0;
+int chan, tagaddr, ancaddr;
+int instance_mode = ANCHOR;
+
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/*! @brief Change the SPI speed configuration on the fly */
+void setHighSpeed_SPI(bool speedValue, DW1000Driver* drv){
+
+  spiStop(drv->spid);
+
+  if (speedValue == FALSE){
+    spiStart(drv->spid, &moduleHalSpiUwbLsConfig);  // low speed spi configuration
+  }
+  else{
+    spiStart(drv->spid, &moduleHalSpiUwbHsConfig); // high speed spi configuration
+  }
+}
+
+/*! @brief entry point to the IRQn event in DW1000 module
+ *
+ * */
+void process_deca_irq(void){
+  do{
+    dwt_isr();
+    //while IRS line active (ARM can only do edge sensitive interrupts)
+  }while(port_CheckEXT_IRQ() == 1);
+}
+
+/*! @brief Check the current value of GPIO pin and return the value */
+apalGpioState_t port_CheckEXT_IRQ(void) {
+  apalGpioState_t  val;
+  apalGpioRead(moduleGpioDw1000Irqn.gpio, &val);
+  return val;
+}
+
+/*! @brief Manually set the chip select pin of the SPI */
+void set_SPI_chip_select(void){
+  apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_HIGH);
+}
+
+/*! @brief Manually reset the chip select pin of the SPI */
+void clear_SPI_chip_select(void){
+  apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_LOW);
+}
+
+/*! @brief Manually reset the DW1000 module  */
+void reset_DW1000(void){
+
+  // Set the pin as output
+  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_OUTPUT);
+
+  //drive the RSTn pin low
+  apalGpioWrite(moduleGpioDw1000Reset.gpio, APAL_GPIO_LOW);
+
+  //put the pin back to tri-state ... as input
+//  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_INPUT); // TODO:
+
+  aosThdMSleep(2);
+}
+
+/*! @brief Configure instance tag/anchor/etc... addresses */
+void addressconfigure(uint8_t s1switch, uint8_t mode){
+  uint16_t instAddress ;
+
+  instance_anchaddr = (((s1switch & SWS1_A1A_MODE) << 2) + (s1switch & SWS1_A2A_MODE) + ((s1switch & SWS1_A3A_MODE) >> 2)) >> 4;
+
+  if(mode == ANCHOR) {
+    if(instance_anchaddr > 3) {
+      instAddress = GATEWAY_ANCHOR_ADDR | 0x4 ; //listener
+    }
+    else {
+      instAddress = GATEWAY_ANCHOR_ADDR | (uint16_t)instance_anchaddr;
+    }
+  }
+  else{
+    instAddress = (uint16_t)instance_anchaddr;
+  }
+
+  instancesetaddresses(instAddress);
+}
+
+/*! @brief returns the use case / operational mode */
+int decarangingmode(uint8_t s1switch){
+  int mode = 0;
+
+  if(s1switch & SWS1_SHF_MODE)  {
+    mode = 1;
+  }
+
+  if(s1switch & SWS1_CH5_MODE) {
+    mode = mode + 2;
+  }
+
+  return mode;
+}
+
+/*! @brief Check connection setting and initialize DW1000 module */
+int32_t inittestapplication(uint8_t s1switch, DW1000Driver* drv){
+  uint32_t devID ;
+  int result;
+
+  setHighSpeed_SPI(FALSE, drv);          //low speed spi max. ~4M
+  devID = instancereaddeviceid() ;
+
+  if(DWT_DEVICE_ID != devID) {
+    clear_SPI_chip_select();
+    Sleep(1);
+    set_SPI_chip_select();
+    Sleep(7);
+    devID = instancereaddeviceid() ;
+    if(DWT_DEVICE_ID != devID){
+      return(-1) ;
+    }    
+    dwt_softreset();
+  }
+
+    reset_DW1000();  //reset the DW1000 by driving the RSTn line low
+
+  if((s1switch & SWS1_ANC_MODE) == 0){
+    instance_mode = TAG;
+  }
+  else{
+    instance_mode = ANCHOR;
+  }
+
+  result = instance_init(drv) ;
+
+  if (0 > result){
+    return(-1) ;
+  }
+
+  setHighSpeed_SPI(TRUE, drv);       // high speed spi max. ~ 20M
+  devID = instancereaddeviceid() ;
+
+  if (DWT_DEVICE_ID != devID){
+    return(-1) ;
+  }
+
+  addressconfigure(s1switch, (uint8_t)instance_mode) ;
+
+  if((instance_mode == ANCHOR) && (instance_anchaddr > 0x3)){
+    instance_mode = LISTENER;
+  }
+
+  instancesetrole(instance_mode) ;       // Set this instance role
+  dr_mode = decarangingmode(s1switch);
+  chan = chConfig[dr_mode].channelNumber ;
+  instance_config(&chConfig[dr_mode], &sfConfig[dr_mode], drv) ;
+
+  return (int32_t)devID;
+}
+
+/*! @brief Main Entry point to Initialization of UWB DW1000 configuration  */
+#pragma GCC optimize ("O3")
+int UWB_Init(DW1000Driver* drv){
+
+  /*! Software defined Configurartion for TAG, ANC, and other settings as needed */
+  s1switch = S1_SWITCH_OFF << 1  // (on = 6.8 Mbps, off = 110 kbps)
+           | S1_SWITCH_OFF << 2  // (on = CH5, off = CH2)
+           | S1_SWITCH_OFF << 3  // (on = Anchor, off = TAG)
+           | S1_SWITCH_OFF << 4  // (configure Tag or anchor ID no.)
+           | S1_SWITCH_OFF << 5  // (configure Tag or anchor ID no.)
+           | S1_SWITCH_OFF << 6  // (configure Tag or anchor ID no.)
+           | S1_SWITCH_OFF << 7; // Not use in this demo
+
+
+  port_DisableEXT_IRQ();           //disable ScenSor IRQ until we configure the device
+
+  if(inittestapplication(s1switch, drv) == -1) {
+    return (-1); //error
+  }
+
+  aosThdMSleep(5);
+
+  port_EnableEXT_IRQ();  //enable DW1000 IRQ before starting
+
+  return 0;
+}
+
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+
+aos_testresult_t aosTestDw1000Func(BaseSequentialStream* stream, aos_test_t* test) {
+
+  aosDbgCheck(test->data != NULL && ((aos_test_dw1000data_t*)test->data)->driver != NULL);
+
+  aos_testresult_t result = {0, 0};
+
+  chprintf(stream, "init DW1000...\n");
+  dwt_initialise(DWT_LOADUCODE, ((aos_test_dw1000data_t*)test->data)->driver);
+  aosThdMSleep(5);
+
+
+/*! Test snippets for DW1000.
+ * @Note: Event IRQ for DW1000 should be tested separately
+ */
+#if defined(TEST_SNIPPETS_DW1000)
+
+  uint32_t actual_deviceId;
+
+  port_DisableEXT_IRQ();
+
+  setHighSpeed_SPI(false, ((aos_test_dw1000data_t*)test->data)->driver);
+  chprintf(stream, "expected device ID (LS SPI): 0xDECA0130\n");
+  aosThdMSleep(5);
+  actual_deviceId = instancereaddeviceid();
+  chprintf(stream, "actual read ID: 0x%x\n", actual_deviceId);
+  aosThdMSleep(5);
+
+  //if the read of device ID fails, the DW1000 could be asleep
+  if(DWT_DEVICE_ID != actual_deviceId){
+
+    clear_SPI_chip_select();
+    aosThdMSleep(1);
+    set_SPI_chip_select();
+    aosThdMSleep(7);
+    actual_deviceId = instancereaddeviceid() ;
+
+    if(DWT_DEVICE_ID != actual_deviceId){
+      chprintf(stream, "SPI is not working or Unsupported Device ID\n");
+      chprintf(stream, "actual device ID is: 0x%x\n", actual_deviceId);
+      chprintf(stream, "expected device ID: 0xDECA0130\n");
+      aosThdMSleep(5);
+    }
+
+    //clear the sleep bit - so that after the hard reset below the DW does not go into sleep
+    dwt_softreset();
+  }
+
+  /*! Test1: Low speed SPI result */
+  if (actual_deviceId == DWT_DEVICE_ID){
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  reset_DW1000();
+
+  chprintf(stream, "initialise instance for DW1000\n");
+  aosThdSleep(1);
+
+  int x_init = instance_init(((aos_test_dw1000data_t*)test->data)->driver) ;
+
+  if (0 != x_init){
+    chprintf(stream, "init error with return value: %d\n", x_init);
+    aosThdSleep(1);
+  }
+  else {
+    chprintf(stream, "init success with return value: %d\n", x_init);
+    aosThdSleep(1);
+  }
+
+  /*! Test2: Initialization  result*/
+  if (x_init == 0){
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  setHighSpeed_SPI(true, ((aos_test_dw1000data_t*)test->data)->driver);
+
+  chprintf(stream, "expected device ID (HS SPI): 0xDECA0130\n");
+  actual_deviceId = instancereaddeviceid();
+  chprintf(stream, "actual read ID: 0x%x\n", actual_deviceId);
+  aosThdMSleep(1);
+
+  /*! Test3: High speed SPI result*/
+  if (actual_deviceId == DWT_DEVICE_ID){
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  port_EnableEXT_IRQ();
+  reset_DW1000();
+
+  chprintf(stream, "initialise the configuration for UWB application\n");
+  aosThdSleep(1);
+
+  int uwb_init = UWB_Init(((aos_test_dw1000data_t*)test->data)->driver);
+
+  if (0 != uwb_init){
+    chprintf(stream, "UWB config error with return value: %d\n", uwb_init);
+    aosThdSleep(1);
+  }
+  else {
+    chprintf(stream, "UWB config success with return value: %d\n", uwb_init);
+    aosThdSleep(1);
+  }
+
+  /*! Test4: UWB configuration result
+   * If all the four tests are passed, the module is ready to run.
+   * Note that the interrupt IRQn should be tested separately.
+   */
+  if (uwb_init == 0){
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  /************** End of TEST_SNIPPETS_DW1000*****************/
+
+#else /* defined(TEST_SNIPPETS_DW1000) */
+
+
+  /*! RUN THE STATE MACHINE DEMO APP (RTLS) */
+
+  chprintf(stream, "initialise the State Machine\n");
+  aosThdSleep(2);
+
+  /* Initialize UWB system with user defined configuration  */
+  int uwb_init = UWB_Init(((aos_test_dw1000data_t*)test->data)->driver);
+
+  if (0 != uwb_init){
+    chprintf(stream, "error in UWB config with return value: %d\n", uwb_init);
+  }
+  else {
+    chprintf(stream, "succeed the init of UWB config\n");
+  }
+  aosThdSleep(1);
+
+  chprintf(stream, "running the RTLS demo application ...\n");
+  aosThdSleep(1);
+
+  /*! Run the localization system demo app as a thread */
+  while(1){
+    instance_run();
+//    aosThdUSleep(10);
+  }
+
+#endif  /* defined(TEST_SNIPPETS_DW1000) */
+
+  return result;
+}
+
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/DW1000_v1/aos_test_DW1000.h b/test/periphery-lld/DW1000_v1/aos_test_DW1000.h
new file mode 100644
index 0000000..efb5666
--- /dev/null
+++ b/test/periphery-lld/DW1000_v1/aos_test_DW1000.h
@@ -0,0 +1,95 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_DW1000_H
+#define AMIROOS_TEST_DW1000_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_DW1000.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  DW1000Driver* driver;
+
+} aos_test_dw1000data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestDw1000Func(BaseSequentialStream* stream, aos_test_t* test);
+
+  extern uint8_t s1switch;
+  extern int instance_anchaddr;
+  extern int dr_mode;
+  extern int chan, tagaddr, ancaddr;
+  extern int instance_mode;
+
+  int UWB_Init(DW1000Driver* drv);
+  int32_t inittestapplication(uint8_t s1switch, DW1000Driver* drv);
+  int decarangingmode(uint8_t s1switch);
+  void addressconfigure(uint8_t s1switch, uint8_t mode);
+  void set_SPI_chip_select(void);
+  void clear_SPI_chip_select(void);
+  void reset_DW1000(void);
+  void setHighSpeed_SPI(bool speedValue, DW1000Driver* drv);
+  apalGpioState_t port_CheckEXT_IRQ(void) ;
+  void process_deca_irq(void);
+
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_DW1000_H */
diff --git a/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.c b/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.c
new file mode 100644
index 0000000..a382b44
--- /dev/null
+++ b/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.c
@@ -0,0 +1,215 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_HMC5883L.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   HMC5338L test function.
+ *
+ * @param[in] stream  Stream for intput/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestHmc5883lFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && (((aos_test_hmc5883ldata_t*)(test->data))->drdyEvtSrc != NULL));
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+  uint8_t rxbuffer[3];
+  uint8_t data;
+  uint8_t conf = 0x70;
+  hmc5883l_lld_config_t cfg;
+  uint16_t mdata[3];
+  uint8_t state;
+  eventmask_t event_mask = 0;
+  event_listener_t el;
+  uint16_t data_reads = 0;
+  aos_timestamp_t start;
+  aos_timestamp_t t;
+
+  chprintf(stream, "check ID...\n");
+  status = hmc5883l_lld_check(((aos_test_hmc5883ldata_t*)test->data)->driver, rxbuffer, 3, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && rxbuffer[0] == HMC5883L_LLD_IDENTIFICATION_A
+                                   && rxbuffer[1] == HMC5883L_LLD_IDENTIFICATION_B
+                                   && rxbuffer[2] == HMC5883L_LLD_IDENTIFICATION_C) {
+    aosTestPassed(stream, &result);
+  } else {
+    chprintf(stream, "\tfailed\n");
+    ++result.failed;
+    chprintf(stream, "\t\tstatus: %d, idA: %d, idB: %d, idC: %d\n", status, rxbuffer[0], rxbuffer[1], rxbuffer[2]);
+    chprintf(stream, "\t\texpected idA: %d, idB: %d, idC: %d\n", HMC5883L_LLD_IDENTIFICATION_A, HMC5883L_LLD_IDENTIFICATION_B, HMC5883L_LLD_IDENTIFICATION_C);
+  }
+
+  chprintf(stream, "read register...\n");
+  status = hmc5883l_lld_read_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_IDENTIFICATION_A, &data, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  if ((status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) && data == HMC5883L_LLD_IDENTIFICATION_A) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "write register...\n");
+  status = hmc5883l_lld_write_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_CONFIG_A, &conf, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  status |= hmc5883l_lld_read_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_CONFIG_A, &data, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  if ((status == APAL_STATUS_SUCCESS || status == APAL_STATUS_WARNING) && data == 0x70) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n, data: d", status, data);
+  }
+
+  chprintf(stream, "read configuration\n");
+  status = hmc5883l_lld_read_config(((aos_test_hmc5883ldata_t*)test->data)->driver, &cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "write configuration\n");
+  cfg.avg = HMC5883L_LLD_AVG1;
+  cfg.outrate = HMC5883L_LLD_75_HZ;
+  cfg.mbias = HMC5883L_LLD_MB_NORMAL;
+  cfg.gain = HMC5883L_LLD_GN_0_GA;
+  cfg.highspeed = HMC5883L_LLD_HS_DISABLE;
+  cfg.mode = HMC5883L_LLD_MM_CONTINUOUS;
+  status = hmc5883l_lld_write_config(((aos_test_hmc5883ldata_t*)test->data)->driver, cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  status |= hmc5883l_lld_read_config(((aos_test_hmc5883ldata_t*)test->data)->driver, &cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  if (status == APAL_STATUS_OK &&
+      cfg.avg == HMC5883L_LLD_AVG1 &&
+      cfg.outrate == HMC5883L_LLD_75_HZ &&
+      cfg.mbias == HMC5883L_LLD_MB_NORMAL &&
+      cfg.gain == HMC5883L_LLD_GN_0_GA &&
+      cfg.highspeed == HMC5883L_LLD_HS_DISABLE &&
+      cfg.mode == HMC5883L_LLD_MM_CONTINUOUS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "read all data for five seconds...\n");
+  status = hmc5883l_lld_set_register(((aos_test_hmc5883ldata_t*)test->data)->driver,HMC5883L_LLD_REGISTER_MODE,HMC5883L_LLD_MM_CONTINUOUS,((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  for (uint8_t i = 0; i < 5; ++i) {
+    status |= hmc5883l_lld_read_data(((aos_test_hmc5883ldata_t*)test->data)->driver, mdata, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+    chprintf(stream, "\t\tX = 0x%04X\tY = 0x%04X\tZ = 0x%04X\n",mdata[0],mdata[1],mdata[2]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_OK) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "read status...\n");
+  status = hmc5883l_lld_read_lock(((aos_test_hmc5883ldata_t*)test->data)->driver, &state, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  chprintf(stream, "\t\tsensor lock: %d\n", state);
+  status |= hmc5883l_lld_read_rdy(((aos_test_hmc5883ldata_t*)test->data)->driver, &state, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  chprintf(stream, "\t\tsensor rdy: %d\n", state);
+  status |= hmc5883l_lld_read_status(((aos_test_hmc5883ldata_t*)test->data)->driver, &state, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  chprintf(stream, "\t\tsensor status: %d\n", state);
+  if (status == APAL_STATUS_OK || status == APAL_STATUS_WARNING) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "interrupt (partial data read)...\n");
+  chEvtRegister(((aos_test_hmc5883ldata_t*)test->data)->drdyEvtSrc, &el, 0);
+  status = hmc5883l_lld_write_config(((aos_test_hmc5883ldata_t*)test->data)->driver, cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  aosThdSSleep(1);
+  status |= hmc5883l_lld_read_data(((aos_test_hmc5883ldata_t*)test->data)->driver, mdata, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  aosThdMSleep(10);
+  event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), TIME_IMMEDIATE);
+  status |= hmc5883l_lld_read_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_DATA_OUT_X_MSB, &data, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  aosThdMSleep(10);
+  status |= hmc5883l_lld_read_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_DATA_OUT_X_LSB, &data, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  aosThdMSleep(10);
+  event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), TIME_IMMEDIATE);
+  chprintf(stream, "\t\teventmask = 0x%08X (should be 0)\n", event_mask);
+  if (event_mask != EVENT_MASK(0)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "interrupt (full data read)...\n");
+  status |= hmc5883l_lld_read_data(((aos_test_hmc5883ldata_t*)test->data)->driver, mdata, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), chTimeUS2I(100 * MICROSECONDS_PER_MILLISECOND));
+  chprintf(stream, "\t\teventmask = 0x%08X (should be 1)\n", event_mask);
+  if (event_mask == EVENT_MASK(0)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read data based on interrupt...\n");
+  status = hmc5883l_lld_read_config(((aos_test_hmc5883ldata_t*)test->data)->driver, &cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  uint8_t mode = HMC5883L_LLD_MM_SINGLE;
+  cfg.mode = mode;
+  status |= hmc5883l_lld_write_config(((aos_test_hmc5883ldata_t*)test->data)->driver, cfg, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  aosSysGetUptime(&start);
+  aosSysGetUptime(&t);
+  status |= hmc5883l_lld_read_data(((aos_test_hmc5883ldata_t*)test->data)->driver, mdata, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+  while (t - start < MICROSECONDS_PER_SECOND) {
+    event_mask = chEvtWaitOneTimeout(EVENT_MASK(0), chTimeUS2I(1000));
+    if (event_mask == EVENT_MASK(0)) {
+      status |= hmc5883l_lld_read_data(((aos_test_hmc5883ldata_t*)test->data)->driver, mdata, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+      data_reads++;
+      status = hmc5883l_lld_write_register(((aos_test_hmc5883ldata_t*)test->data)->driver, HMC5883L_LLD_REGISTER_CONFIG_A+2, &mode, 1, ((aos_test_hmc5883ldata_t*)test->data)->timeout);
+    }
+    aosSysGetUptime(&t);
+  }
+  chEvtUnregister(((aos_test_hmc5883ldata_t*)test->data)->drdyEvtSrc, &el);
+  aosTestInfoMsg(stream,"Read data %u times in a second\n", data_reads);
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(HMC5883LDriver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
diff --git a/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.h b/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.h
new file mode 100644
index 0000000..9178bdf
--- /dev/null
+++ b/test/periphery-lld/HMC5883L_v1/aos_test_HMC5883L.h
@@ -0,0 +1,91 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_HMC5883L_H
+#define AMIROOS_TEST_HMC5883L_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_HMC5883L.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Constum data structure for this test.
+ */
+typedef struct {
+  /**
+   * @brief   HMC5338L driver to use.
+   */
+  HMC5883LDriver* driver;
+
+  /**
+   * @brief   Event source for certain tests.
+   */
+  event_source_t *drdyEvtSrc;
+
+  /**
+   * @brief   Event flags to watch.
+   */
+  eventflags_t evtflags;
+
+  /**
+   * @brief   Timeout value in microseconds.
+   */
+  apalTime_t timeout;
+} aos_test_hmc5883ldata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestHmc5883lFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_HMC5883L_H */
